library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

entity convert32 is
    Port ( DATA : in  STD_LOGIC_VECTOR(5 downto 0);
			  SW1 : in  STD_LOGIC;			           
           DIG : out  STD_LOGIC_VECTOR (2 downto 0);		--PARA MUX DOS DIGITOS
			  OUT_DATA : out  STD_LOGIC_VECTOR (1 downto 0);--PARA MUX DE SAIDA
			  SEL_DIG : out  STD_LOGIC_VECTOR (1 downto 0)	--PARA MUX INTERMEDIARIO
          );
end convert32;

architecture convert32_comp of convert32 is

SIGNAL TMP_OUT_DATA : STD_LOGIC_VECTOR (1 downto 0) := "00"; 
SIGNAL TMP_SEL_DIG : STD_LOGIC_VECTOR (1 downto 0) := "00"; 
SIGNAL TMP_DIG : STD_LOGIC_VECTOR (2 downto 0) := "000"; 

begin

TMP_OUT_DATA <= "11" WHEN DATA = "100100" ELSE
			       "10" WHEN DATA = "011000" ELSE
			       "01" WHEN DATA = "001100" ELSE
			       "00" WHEN DATA = "000000" ELSE
				    TMP_OUT_DATA;
				
OUT_DATA <= TMP_OUT_DATA;
			  
TMP_SEL_DIG <= "00" WHEN DATA = "001010" OR DATA = "010110" OR DATA = "100010" ELSE
			  "01" WHEN DATA = "000010" OR DATA = "001110" OR DATA = "011010" OR DATA = "100110" ELSE
			  "10" WHEN DATA = "000000" OR DATA = "001100" OR DATA = "011000" OR DATA = "100100" ELSE
			  TMP_SEL_DIG;
			  
SEL_DIG <= TMP_SEL_DIG;
			  
TMP_DIG <= "000" WHEN (DATA = "001000" OR DATA = "010100" OR DATA = "100000" OR DATA = "101100") AND SW1 = '1' ELSE
	        "001" WHEN (DATA = "000110" OR DATA = "010010" OR DATA = "011110" OR DATA = "101010") AND SW1 = '1' ELSE
		     "010" WHEN (DATA = "000100" OR DATA = "010000" OR DATA = "011100" OR DATA = "101000") AND SW1 = '1' ELSE
		     "011" WHEN (DATA = "000010" OR DATA = "001110" OR DATA = "011010" OR DATA = "100110") AND SW1 = '1' ELSE
		     "100" WHEN (DATA = "001000" OR DATA = "010100" OR DATA = "100000" OR DATA = "101100") AND SW1 = '0' ELSE
		     "101" WHEN (DATA = "000110" OR DATA = "010010" OR DATA = "011110" OR DATA = "101010") AND SW1 = '0' ELSE
		     "110" WHEN (DATA = "000100" OR DATA = "010000" OR DATA = "011100" OR DATA = "101000") AND SW1 = '0' ELSE
		     "111" WHEN (DATA = "000010" OR DATA = "001110" OR DATA = "011010" OR DATA = "100110") AND SW1 = '0' ELSE
		     TMP_DIG;
		 
DIG <= TMP_DIG;

end convert32_comp;