library IEEE;

entity hexadecimal32 is
    Port ( 			
			bin	:IN	BIT_VECTOR (31 downto 0);
			hex0	:OUT	BIT_VECTOR (7 downto 0);
			hex1	:OUT	BIT_VECTOR (7 downto 0);
			hex2	:OUT	BIT_VECTOR (7 downto 0);
			hex3	:OUT	BIT_VECTOR (7 downto 0);
			hex4	:OUT	BIT_VECTOR (7 downto 0);
			hex5	:OUT	BIT_VECTOR (7 downto 0);
			hex6	:OUT	BIT_VECTOR (7 downto 0);
			hex7	:OUT	BIT_VECTOR (7 downto 0)
          );
end hexadecimal32;

architecture hexadecimal32_arc of hexadecimal32 is

function convert(binary:BIT_VECTOR) return BIT_VECTOR is

	variable tmp:	BIT_VECTOR(3 downto 0) := binary;
	variable output: BIT_VECTOR(7 downto 0) := (others => '0');
	
	begin
	
			case tmp(3 downto 0) is
			
				when "1010" =>
					output := "01000001";
				
				when "1011" =>
					output := "01000010";
									
				when "1100" =>
					output := "01000011";
									
				when "1101" =>
					output := "01000100";
					
				when "1110" =>
					output := "01000101";
					
				when "1111" =>
					output := "01000110";
		
				when others =>
					output(7 downto 4) := "0011";
					output(3 downto 0) := tmp;
			
			end case;
					
	return output;

end convert;

begin

	hex0 <= convert(bin(3 downto 0));
	hex1 <= convert(bin(7 downto 4));
	hex2 <= convert(bin(11 downto 8));
	hex3 <= convert(bin(15 downto 12));
	hex4 <= convert(bin(19 downto 16));
	hex5 <= convert(bin(23 downto 20));
	hex6 <= convert(bin(27 downto 24));
	hex7 <= convert(bin(31 downto 28));
	
end hexadecimal32_arc;